#include "dingoo/minimal.h"
#include <limits.h>
#include <fcntl.h>
#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "hack.h"
#include "ui.h"

int master_volume = 50;

extern void UpdateGame(unsigned long ulButtons, unsigned long ulJoystick);
extern void RenderScreen(unsigned short *pus, unsigned long ulButtons);

void *dingoo_screen;
int stickfd;

static void dzzInitScreen()
{
    // Start Minimal lib
    dingoo_init(16000,16,0,336,20);

    // Allocate screen memory
    dingoo_screen = malloc(320*240*2 + 32);
    if(dingoo_screen == NULL) return;
    memset(dingoo_screen, 0, 320*240*2 + 32);

    //dingoo_screen = dingoo_screen32;
    //dingoo_clear_video();

    // Setup the screen
    //lc_screensize(320, 240);
    //lc_layerpos(1, 0, 0, 319, 239);
    //lc_setlayer(1, true, false, false, false, RGB565);
    //printf( "Screen configured\n");

    // Open controls
    //stickfd = open("/dev/GPIO", O_RDWR | O_NDELAY );
    //if(stickfd < 0){
    //  printf( "GPIO OPEN FAIL\n");
    //} else {
    //  printf( "GPIO Opened!\n");
    //}
}

void dzzCleanupHardware()
{
  free(dingoo_screen);
  dingoo_screen = NULL;
  dingoo_deinit();
  // Close libcastor
  //lc_exit();

  // Close controls
  //close(stickfd);
  //printf( "System released\n");
}

void dzzFlipScreen()
{
   memcpy((void*)dingoo_screen32, (void*)dingoo_screen, 320*240*2);
   dingoo_flush_video();
}

#include "splash.c"

void QuickInitUI(int bDoSplash)
{
  dzzInitScreen();
  if(bDoSplash)
  {
    memcpy((void*)dingoo_screen32, g_usSplashData, 320*240*2);
    dingoo_flush_video();
    dzzFlipScreen();
    memcpy((void*)dingoo_screen32, g_usSplashData, 320*240*2);
    dingoo_flush_video();
    dzzFlipScreen();
  }
}

unsigned long dzzGetButtons()
{
  unsigned long dingookey;
  dingookey = dingoo_joystick_read(1);
  //read(stickfd, &dingookey, 4);
  return dingookey;
}

int dzzShiftDown()
{
  if(dzzGetButtons() & DINGOO_L)
    return 1;
  return 0;
}


unsigned long dzzGetJoystick()
{
  unsigned long b;

  b = dingoo_joystick_read(1);
  if(b & DINGOO_UP)
  {
    if(b & DINGOO_UP && DINGOO_LEFT)
      return JOYDIR_UUL;
    if(b & DINGOO_UP && DINGOO_RIGHT)
      return JOYDIR_UUR;
    return JOYDIR_U;
  }
  if(b & DINGOO_LEFT)
  {
    if(b & DINGOO_UP && DINGOO_LEFT)
      return JOYDIR_LUL;
    if(b & DINGOO_DOWN && DINGOO_LEFT)
      return JOYDIR_LDL;
    return JOYDIR_L;
  }
  if(b & DINGOO_DOWN)
  {
    if(b & DINGOO_DOWN && DINGOO_LEFT)
      return JOYDIR_DDL;
    if(b & DINGOO_DOWN && DINGOO_RIGHT)
      return JOYDIR_DDR;
    return JOYDIR_D;
  }
  if(b & DINGOO_RIGHT)
  {
    if(b & DINGOO_UP && DINGOO_RIGHT)
      return JOYDIR_RUR;
    if(b & DINGOO_DOWN && DINGOO_RIGHT)
      return JOYDIR_RDR;
    return JOYDIR_R;
  }
  if(b & DINGOO_UP && DINGOO_LEFT)
    return JOYDIR_UL;
  if(b & DINGOO_UP && DINGOO_RIGHT)
    return JOYDIR_UR;
  if(b & DINGOO_DOWN && DINGOO_LEFT)
    return JOYDIR_DL;
  if(b & DINGOO_DOWN && DINGOO_RIGHT)
    return JOYDIR_DR;
  return JOYDIR_NONE;
}

// convert the joystick direction to a "mode 2" 8-way

unsigned long NormalizeJoystick(unsigned long ulIn)
{
  switch(ulIn)
  {
    case JOYDIR_U:
    case JOYDIR_UUL:
    case JOYDIR_UUR:
      return JOYDIR_U;

    case JOYDIR_UL:
      return JOYDIR_UL;

    case JOYDIR_LUL:
    case JOYDIR_L:
    case JOYDIR_LDL:
      return JOYDIR_L;

    case JOYDIR_DL:
      return JOYDIR_DL;

    case JOYDIR_DDL:
    case JOYDIR_D:
    case JOYDIR_DDR:
      return JOYDIR_D;

    case JOYDIR_DR:
      return JOYDIR_DR;

    case JOYDIR_RDR:
    case JOYDIR_R:
    case JOYDIR_RUR:
      return JOYDIR_R;

    case JOYDIR_UR:
      return JOYDIR_UR;

    default:
      break;
  }
  return JOYDIR_NONE;
}

#define LONG_LIMIT (LONG_MAX/1000)

unsigned int g_ulFrameTimer = 0;

unsigned long GetTime( void )
{
  struct timeval tv;
  unsigned long time;
  //clock_t time;
  //time = dingoo_timer_read();
  gettimeofday(&tv, NULL);
  time = tv.tv_usec/1000;
  return time;
}

void dzzStartFrameTimer()
{
  g_ulFrameTimer = GetTime();
}

int dzzGetFrameTimer()
{
  unsigned long ul;

  ul = GetTime();
  if(ul > g_ulFrameTimer)
    return (int) (ul - g_ulFrameTimer);
  // wrapped around
  return (int) (ul + (LONG_LIMIT-g_ulFrameTimer));
}

unsigned int g_ulJoystickTimer = 0;

void dzzStartJoystickTimer()
{
  g_ulJoystickTimer = GetTime();
}

int dzzGetJoystickTimer()
{
  unsigned long ul;

  ul = GetTime();
  if(ul > g_ulJoystickTimer)
    return (int) (ul - g_ulJoystickTimer);
  // wrapped around
  return (int) (ul + (LONG_LIMIT-g_ulFrameTimer));
}

unsigned int g_ulStickClickTimer = 0;

void dzzStartStickClickTimer()
{
  g_ulStickClickTimer = GetTime();
}

int dzzGetStickClickTimer()
{
  unsigned long ul;

  ul = GetTime();
  if(ul > g_ulStickClickTimer)
    return (int) (ul - g_ulStickClickTimer);
  // wrapped around
  return (int) (ul + (LONG_LIMIT-g_ulFrameTimer));
}

void dzzMicroSleep(int nMicros)
{
  usleep((unsigned long) nMicros);
}

static volatile int g_bUIThreadRunning = 0;
static volatile int g_bExitUIThread = 0;

static void *UIThread(void *p)
{
  unsigned long ulButtons;
  unsigned long ulJoystick;

  g_bUIThreadRunning = 1;
  
  while(!g_bExitUIThread)
  {
    // do any game updating.  About all we'd do here is
    // autoscroll the map
    dzzStartFrameTimer();
    ulButtons = dzzGetButtons();
    ulJoystick = dzzGetJoystick();
    ulJoystick = NormalizeJoystick(ulJoystick);
    UpdateGame(ulButtons, ulJoystick);

    // draw the screen buffer
    // using the memscreen and current state, etc
    RenderScreen((void*)dingoo_screen, ulButtons);
    // wait for vertical sync
    while(dzzGetFrameTimer() < 16.66)
      dzzMicroSleep(5000);

    // flip the screen
    dzzFlipScreen();
  }
  dzzCleanupHardware();
  g_bUIThreadRunning = 0;
  return 0;
}

void StartUIThread()
{
  pthread_t thr;
  pthread_create(&thr, NULL, UIThread, NULL);
}

void ShutdownUIThread()
{
  g_bExitUIThread = 1;
  while(g_bUIThreadRunning)
  {
    usleep(10000);
  }
}
