
/*  SCCS Id: @(#)ntconf.h 3.4 2002/03/10  */
/* Copyright (c) NetHack PC Development Team 1993, 1994.  */
/* NetHack may be freely redistributed.  See license for details. */

#ifndef GP2XCONF_H
#define GP2XCONF_H

#include <string.h> /* Provides prototypes of strncmpi(), etc.     */
#include <strings.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

/* #define SHELL  /* nt use of pcsys routines caused a hang */

// #define RANDOM   /* have Berkeley random(3) */
// #define TEXTCOLOR  /* Color text */

#define EXEPATH     /* Allow .exe location to be used as HACKDIR */
#define TRADITIONAL_GLYPHMAP  /* Store glyph mappings at level change time */

#define PC_LOCKING    /* Prevent overwrites of aborted or in-progress games */
        /* without first receiving confirmation. */

// #define HOLD_LOCKFILE_OPEN /* Keep an exclusive lock on the .0 file */

#define SELF_RECOVER    /* Allow the game itself to recover from an aborted game */
#define INSURANCE
#define DEBUG_SAVE

// #define USER_SOUNDS
/*#include <time.h>
 * -----------------------------------------------------------------
 *  The remaining code shouldn't need modification.
 * -----------------------------------------------------------------
 */
//#define SHORT_FILENAMES  /* All NT filesystems support long names now */

#ifdef MICRO
#undef MICRO      /* never define this! */
#endif

#define NOCWD_ASSUMPTIONS /* Always define this. There are assumptions that
                                   it is defined for WIN32.
           Allow paths to be specified for HACKDIR,
           LEVELDIR, SAVEDIR, BONESDIR, DATADIR,
           SCOREDIR, LOCKDIR, CONFIGDIR, and TROUBLEDIR */

#define LEVELDIR "lvl"
#define SAVEDIR "sav"
#define BONESDIR "bns"
#define DATADIR "dat"
#define SCOREDIR "scre"
#define LOCKDIR "lock"
#define CONFIGDIR "cfg"
#define TROUBLEDIR "tro"


#define NO_TERMS
#define ASCIIGRAPH

#ifdef OPTIONS_USED
#undef OPTIONS_USED
#endif
#define OPTIONS_USED  "guioptions"
#define OPTIONS_FILE OPTIONS_USED

#define PORT_ID "gp2x"

/* Stuff to help the user with some common, yet significant errors */
#define INTERJECT_PANIC   0
#define INTERJECTION_TYPES  (INTERJECT_PANIC + 1)
extern void FDECL(interject_assistance, (int,int,genericptr_t,genericptr_t));
extern void FDECL(interject, (int));


//#ifdef STRNCMPI
//#define strncmp(a,b,c) strncmp(a,b,c)
//#endif

#define PATHLEN   BUFSZ /* maximum pathlength */
#define FILENAME  BUFSZ /* maximum filename length (conservative) */

#if defined(_MAX_PATH) && defined(_MAX_FNAME)
# if (_MAX_PATH < BUFSZ) && (_MAX_FNAME < BUFSZ)
#undef PATHLEN
#undef FILENAME
#define PATHLEN   _MAX_PATH
#define FILENAME  _MAX_FNAME
#endif
#endif

//#define NO_SIGNAL
#define index strchr
#define rindex  strrchr

extern void error(const char *, ...);
extern void regularize(char *s);
extern void append_slash(char *name);
#ifdef WIN32
#include <io.h>
#endif
#define USE_STDARG
#ifdef RANDOM
/* Use the high quality random number routines. */
#define Rand()  random()
#else
#define Rand()	lrand48()
#endif

#define FCMASK  0660  /* file creation mask */
#define HLOCK "perm"



#ifndef SIG_RET_TYPE
#define SIG_RET_TYPE void (*)()
#endif


#ifndef M
#define M(c)    ((char) (0x80 | (c)))
/* #define M(c)   ((c) - 128) */
#endif

#ifndef C
#define C(c)    (0x1f & (c))
#endif

#if 0
extern char levels[], bones[], permbones[],
#endif /* 0 */

/* this was part of the MICRO stuff in the past */
extern const char *alllevels, *allbones;
extern char hackdir[];
#define ABORT C('a')
#define getuid() 1
#define getlogin() ((char *)0)

#ifndef alloca
#define ALLOCA_HACK /* used in util/panic.c */
#endif

#ifndef REDO
#define Getchar nhgetch
#endif
#define tgetch getchar

#endif /* GP2XCONF_H */
