
typedef struct TextWindow
{
	int nTextLines;
	int nX;
	int nY;
	int nW;
	int nH;
	int nVisibleLines;
	int nTopLine;
	char szLines[1000][100];
} TextWindow;

#define MAX_TEXT_WINDOWS  30

TextWindow *g_pTextWindows[MAX_TEXT_WINDOWS] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
};

void DrawTextWindow(unsigned short *pus, TextWindow *pWin)
{
	int n, nTop;

	// draw the outline
	DrawLine(pus, nX-1, nY-1, nX-1, nY+nH, XRGB(0,0,31));
	DrawLine(pus, nX+nW, nY-1, nX+nW, nY+nH, XRGB(0,0,31));
	DrawLine(pus, nX-1, nY-1, nX+nW, nY-1, XRGB(0,0,31));
	DrawLine(pus, nX-1, nY+nH, nX+nW, nY+nH, XRGB(0,0,31));
	// clear the background
	DrawRect(pus, nX, nY, nW, nH, XRGB(31,63,31));
	// draw the scrollbar if needed
	// DZZ: todo
	// draw the text itself
	nTop = nY + 2;
	for(n = pWin->nTopLine; n < pWin->nTopLine + pWin->nVisibleLines; n++)
	{
		if(n >= pWin->nTextLines)
			break;
		DrawText(pus, nX+2, nTop, pWin->szLines[n], XRGB(0,0,0));
	}
}

void InitTextWindow(TextWindow *pWin)
{
	pWin->nTextLines = 0;
	pWin->nTopLine = 0;
}

void AppendTextToTextWindow(TextWindow *pWin, char *pszText)
{
	if(pWin->nTextLines >= 1000)
		return;
	strcpy(pWin->szLines[pWin->nTextLines], pszText);
	pWin->nTextLines++;
}

void PositionTextWindow(TextWindow *pWin)
{
	int n;
	int nW;
	int nMaxWidth = 0;

	for(n = 0; n < nTextLines; n++)
	{
		nW = GetStringWidth(pWin->szLines[n]);
		if(nW > nMaxWidth)
			nMaxWidth = nW;
	}
	nMaxWidth += 4; // border
	if(pWin->nTextLines > 18)
	{
		nMaxWidth += 10; // scrollbar
		pWin->nVisibleLines = 18;
	}
	else
		pWin->nVisibleLines = pWin->nTextLines;
	if(nMaxWidth > 310)
		nMaxWidth = 310;
	pWin->nW = nMaxWidth;
	pWin->nX = (320 - pWin->nW) / 2;
	pWin->nH = 10 * pWin->nVisibleLines + 4;
	pWin->nY = 30 + (190 - pWin->nH) / 2;
}

void ScrollTextWindow(TextWindow *pWin, int bDown)
{
	if(bDown)
	{
		if(pWin->nTopLine + pWin->nVisibleLines >= pWin->nTextLines)
			return; // cannot scroll further
		pWin->nTopLine++;
	}
	else
	{
		if(pWin->nTopLine > 0)
			pWin->nTopLine--;
	}
}

int NewTextWindow()
{
	int n;
	TextWindow *pWin:
	pWin = (TextWindow *) malloc(sizeof(TextWindow));
	InitTextWindow(pWin);
	for(n = 10; n < MAX_TEXT_WINDOWS; n++)
	{
		if(g_pTextWindows[n] == NULL)
		{
			g_pTextWindows[n] = pWin;
			return n;
		}
	}
	free(pWin);
	return -1;
}
